// ===============================================
// CSCI 3230 Data Structures
// Instructor: Weitian Tong, Ph.D.
//
// Coding Quiz
//
// =============================================== Requirements
// Implement the BFS algorithm based on the provided template. 

// The output should be:

// The BFS: 
// I am exploring A
//      I am adding B to the queue!
//      I am adding C to the queue!
//      I am adding D to the queue!
//      I am adding E to the queue!
// Finish exploring A
// I am exploring B
// Finish exploring B
// I am exploring C
// Finish exploring C
// I am exploring D
// Finish exploring D
// I am exploring E
// Finish exploring E

//
// =============================================== Note
//
//  1. DO NOT DELETE ANY COMMENT!!!
//  2. Modify the file name to "BFS.java" before compiling it.
//
// ===============================================

import java.util.ArrayList;
import java.util.Queue;
import java.util.LinkedList;
import java.util.PriorityQueue;
import java.util.HashSet;
import java.util.Comparator;


// ==========================================================
// Class MyGraph: provide graphs algorithms 
class MyGraph {
    // -----------------------------------------
    ArrayList<Node> nodes=new ArrayList<>(); // A list of nodes
    int adjMatrix[][]; // adjmatrix

    // -----------------------------------------constructors 
    public MyGraph(ArrayList<Node> nodes, int[][] adjMatrix) {  
        this.adjMatrix = adjMatrix;
        this.nodes = nodes;
    }
    public MyGraph(ArrayList<Node> nodes) { 
        this.adjMatrix = new int[nodes.size()][nodes.size()];
        this.nodes = nodes;
    }
    
    // -----------------------------------------BFS
    public void bfs(Node s) {
        // COMPLETE THIS BLOCK

        
    } 

    // ADD ANY OTHER NECESSARY METHODS.
}

// ==========================================================
// ==========================================================
// Class Node
class Node {
    int data;
    String name;
    int color; // GRAY: -1, RED: -2, BLACK: -3 
    ArrayList<Node> neighbours;

    int d; // record distance information
    Node p; // record parent information

    Node(int data, String name) {
        this.data = data;
        this.name = name;
        this.neighbours = new ArrayList<>();
        this.color = -1; 
        // By default it is gray. 
        // And we can skip the initialization step

        this.d = 100000000;
        this.p = null;
    }

    public void addneighbours(Node neighbourNode) {
        this.neighbours.add(neighbourNode);
    }
    public ArrayList<Node> getNeighbours() {
        return this.neighbours;
    }
    public void setNeighbours(ArrayList<Node> neighbours) {
        this.neighbours = neighbours;
    }

}

class MyComparator implements Comparator<Node> {
    @Override
    public int compare(Node node1, Node node2) {
        if (node1.d < node2.d)
            return -1;
        if (node1.d > node2.d)
            return 1;
        return 0;
    }
}




public class BFS {  
    public static void main(String arg[]) {
        Node A =new Node(1, "A"); Node B =new Node(2, "B"); 
        Node C =new Node(3, "C"); Node D =new Node(4, "D");
        Node E =new Node(5, "E");

        A.addneighbours(B); A.addneighbours(C); A.addneighbours(D); A.addneighbours(E);
        B.addneighbours(A); B.addneighbours(C);
        C.addneighbours(B); C.addneighbours(A); C.addneighbours(D); C.addneighbours(E);
        D.addneighbours(A); D.addneighbours(C);
        E.addneighbours(A); E.addneighbours(C);
         
        ArrayList<Node> nodes=new ArrayList<>();
        nodes.add(A); nodes.add(B); nodes.add(C); nodes.add(D); nodes.add(E); 
         
        MyGraph graph1 = new MyGraph(nodes);  
        
        // ----------------------------------------- Test BFS
        System.out.println("The BFS: ");
        graph1.bfs(A);
        

    }
}