// ===============================================
// CSCI 3230 Data Structures
// Instructor: Weitian Tong, Ph.D.
//
// Coding Quiz
//
// =============================================== Requirements
// Implement the Dijstra's algorithm based on the provided template. 

// The output should be:

// (A, 0) --> (B, 7) --> (C, 15) --> (D, 5) --> (E, 14) --> (F, 11) --> (G, 22) --> End!

//
// =============================================== Note
//
//  1. DO NOT DELETE ANY COMMENT!!!
//  2. Modify the file name to "Dijstra.java" before compiling it.
//
// ===============================================

import java.util.ArrayList;
import java.util.Queue;
import java.util.LinkedList;
import java.util.PriorityQueue;
import java.util.HashSet;
import java.util.Comparator;


// ==========================================================
// Class MyGraph: provide graphs algorithms 
class MyGraph {
    // -----------------------------------------
    ArrayList<Node> nodes=new ArrayList<>(); // A list of nodes
    int adjMatrix[][]; // adjmatrix

    // -----------------------------------------constructors 
    public MyGraph(ArrayList<Node> nodes, int[][] adjMatrix) {  
        this.adjMatrix = adjMatrix;
        this.nodes = nodes;
    }
    public MyGraph(ArrayList<Node> nodes) { 
        this.adjMatrix = new int[nodes.size()][nodes.size()];
        this.nodes = nodes;
    }

    // -----------------------------------------Dijsktra's alg
    void dijsktraAlg(Node s, int[][] adjMatrix) {
        PriorityQueue<Node> priorityQueue;
        priorityQueue = new PriorityQueue<Node>(new MyComparator());
        
        // COMPLETE THIS BLOCK


        print(this.nodes);
    }

    void relax(Node u, Node v, int[][] adjMatrix, PriorityQueue<Node> priorityQueue) {
        // COMPLETE THIS BLOCK



        
    }

    // -----------------------------------------Auxiliary printing methods
    void print(PriorityQueue<Node> priorityQueue) {
        for (Node node : priorityQueue) {
            System.out.print("(" + node.name + ", " + node.d + ") --> ");
        }
        System.out.println("End!");
    }
    void print(ArrayList<Node> priorityQueue) {
        for (Node node : priorityQueue) {
            System.out.print("(" + node.name + ", " + node.d + ") --> ");
        }
        System.out.println("End!");
    }
    void print(HashSet<Integer> set) {
        for (Integer x : set) {
            System.out.print(x + " --> ");
        }
        System.out.println("End!");
    }
}

// ==========================================================
// Class Node
class Node {
    int data;
    String name;
    int color; // GRAY: -1, RED: -2, BLACK: -3 
    ArrayList<Node> neighbours;

    int d; // record distance information
    Node p; // record parent 

    Node(int data, String name) {
        this.data = data;
        this.name = name;
        this.neighbours = new ArrayList<>();
        this.color = -1; // by default so that we can skip the initialization step

        this.d = 100000000;
        this.p = null;
    }

    public void addneighbours(Node neighbourNode) {
        this.neighbours.add(neighbourNode);
    }
    public ArrayList<Node> getNeighbours() {
        return this.neighbours;
    }
    public void setNeighbours(ArrayList<Node> neighbours) {
        this.neighbours = neighbours;
    }

}

class MyComparator implements Comparator<Node> {
    @Override
    public int compare(Node node1, Node node2) {
        if (node1.d < node2.d)
            return -1;
        if (node1.d > node2.d)
            return 1;
        return 0;
    }
}


public class Dijkstra {  
    public static void main(String arg[]) {
        Node A =new Node(1, "A"); Node B =new Node(2, "B"); Node C =new Node(3, "C"); Node D =new Node(4, "D");
        Node E =new Node(5, "E"); Node F =new Node(6, "F"); Node G =new Node(7, "G"); 
        A.addneighbours(B); A.addneighbours(D);
        B.addneighbours(A); B.addneighbours(D); B.addneighbours(E); B.addneighbours(C);
        C.addneighbours(B); C.addneighbours(E);
        D.addneighbours(A); D.addneighbours(B); D.addneighbours(E); D.addneighbours(F);
        E.addneighbours(B); E.addneighbours(C); E.addneighbours(D); E.addneighbours(F); E.addneighbours(G); 
        F.addneighbours(D); F.addneighbours(E); F.addneighbours(G); 
        G.addneighbours(E); G.addneighbours(F); 

        int M = 10000000;
        int[][] adjMatrix = {{0, 7, M, 5, M, M, M}, 
                             {7, 0, 8, 9, 7, M, M}, 
                             {M, 8, 0, M, 5, M, M}, 
                             {5, 9, M, 0, 15, 6, M}, 
                             {M, 7, 5, 15, 0, 8, 9}, 
                             {M, M, M, 6, 8, 0, 11}, 
                             {M, M, M, M, 9, 11, 0}}; // Adjmatrix to record edge weight
        
        ArrayList<Node> nodes=new ArrayList<>();
        nodes.add(A); nodes.add(B); nodes.add(C); nodes.add(D); nodes.add(E); nodes.add(F); nodes.add(G);

        MyGraph graph = new MyGraph(nodes, adjMatrix);  

        // -----------------------------------------Dijstra's alg
        graph.dijsktraAlg(A, adjMatrix);
        

    }
}