// ===============================================
// CSCI 3230 Data Structures
// Instructor: Weitian Tong, Ph.D.
//
// Coding Quiz 2
//
// =============================================== Requirements
//
// Please complete MyDoublyLinkedList class.  
//
// The output should be:
// 
//       Test MyDoublyLinkedList:.....
//       (1, 2, 3, 4, 5)
//       (-2, -1, 1, 2, 3, 4, 5)
//       (-2, 100, -1, 1, 2, 3, 4, 5)
//       (100, -1, 1, 2, 3, 4, 5)
//       (100, -1, 1, 2, 3, 4)
//
// =============================================== Note
//
//  1. DO NOT DELETE ANY COMMENT!!!
//  2. Modify the file name to "MyDoublyLinkedList.java" before compiling it.
// 
// ===============================================

public class MyDoublyLinkedList<E> {

  // --------------------- Data field
  public Node<E> header; // parent of head, dummy node          
  public Node<E> trailer; // child of tail, dummy node                 
  public int size = 0;   

  // --------------------- Method field            
  public MyDoublyLinkedList() {
    header = new Node<>(null, null, null);      
    trailer = new Node<>(null, header, null); // header <-- trailer
    header.setNext(trailer); // header --> trailer
  }
  
  public int size() { return size; }
  public boolean isEmpty() { return size == 0; }
  
  public E first() {
    if (isEmpty()) return null;
    return header.getNext().getElement();   
  }

  
  public E last() {
    if (isEmpty()) return null;
    return trailer.getPrev().getElement();    
  }

  public void addFirst(E e) {
    addBetween(e, header, header.getNext());    
  }

  public void addLast(E e) {
    addBetween(e, trailer.getPrev(), trailer);  
  }

 
  public E removeFirst() {
    if (isEmpty()) return null;                 
    return remove(header.getNext());            
  }

  public E removeLast() {
    if (isEmpty()) return null;                  
    return remove(trailer.getPrev());         
  }

  private void addBetween(E e, Node<E> predecessor, Node<E> successor) {
    // Complete this block


  }

  private E remove(Node<E> node) {
    // Complete this block


  }

  public String toString() {
    StringBuilder sb = new StringBuilder("(");
    Node<E> walk = header.getNext();
    while (walk != trailer) {
      sb.append(walk.getElement());
      walk = walk.getNext();
      if (walk != trailer)
        sb.append(", ");
    }
    sb.append(")");
    return sb.toString();
  }
  

  public static void main(String[] args) {
	  System.out.println("Test MyDoublyLinkedList:.....");
	  MyDoublyLinkedList<Integer> list = new MyDoublyLinkedList<Integer>();
    list.addLast(1);
    list.addLast(2);
    list.addLast(3);
    list.addLast(4);
    list.addLast(5);
    System.out.println(list.toString()); // (1,2,3,4,5)

    list.addFirst(-1);
    list.addFirst(-2);
    System.out.println(list.toString()); // (-2,-1,1,2,3,4,5)

    list.addBetween(100, list.header.getNext(), list.header.getNext().getNext());
    System.out.println(list.toString()); 

    list.removeFirst();
    System.out.println(list.toString()); 

    list.removeLast();
    System.out.println(list.toString()); 
  }
} 


//----------- Node class -----------
class Node<E> {
    private E element;             
    private Node<E> prev;  
    private Node<E> next;         
    public Node(E e, Node<E> p, Node<E> n) {
      element = e;
      prev = p;
      next = n;
    }
    public E getElement() { return element; }
    public Node<E> getPrev() { return prev; }
    public Node<E> getNext() { return next; }
    public void setPrev(Node<E> p) { prev = p; }
    public void setNext(Node<E> n) { next = n; }
} 
//----------- end of Node class -----------

