// ===============================================
// CSCI 3230 Data Structures
// Instructor: Weitian Tong, Ph.D.
//
// Coding Quiz 5
//
// =============================================== Requirements
// Implement a BinarySearchTree class using the linked structure. 
// Hint: The implementation of binary tree with linked structure are provided (LinkedBinaryTree.java and BTNode.java). 
//
// The output should be:
// 
// ============================= Test BinarySearchTree
// Size of the tree: 6
// Height of the tree: 3

// inOrder: 1	2	4	6	8	9	

// ------------------ Test search
// 4 with parent 2 and leftChild: null and rightChild: null


// ------------------ Test insert
// 1	2	4	5	6	8	9	

// ------------------ Test delete
// ---------before delete()
// 1	2	4	5	6	8	9	

// 1	2	5	6	8	9	

// ------------------ Test delete
// ---------before delete()
// 1	2	3	5	6	8	9	

// ---------after delete()
// 1	2	5	6	8	9	

// 5 with parent 1 and leftChild: 2 and rightChild: 8
// 2 with parent 5 and leftChild: null and rightChild: null
// 1 with parent null and leftChild: null and rightChild: 5
//
// =============================================== Note
//
//  1. DO NOT DELETE ANY COMMENT!!!
//  2. Modify the file name to "BinarySearchTree.java" before compiling it.
//
// ===============================================


public class BinarySearchTree<E extends Comparable<E>> extends LinkedBinaryTree<E> {

	public BinarySearchTree(BTNode<E> root){
		super(root);
	}
	
	/* It is the search method. */
	public BTNode<E> search(E key){
		BTNode<E> current = this.getRoot();
		while (current != null) {
			if(key.compareTo(current.getElement()) == 0){
				return current;
			}else if(key.compareTo(current.getElement()) < 0){
				current = current.getLeftChild();
			}else{
				current = current.getRightChild();
			}
		}
		System.out.println("Did not find the key!");
		return null;		
	}

	/* It is the insert method. */
	public void insert(BTNode<E> node){
		if(getRoot() == null){
			setRoot(node);
			return;
		}
		BTNode<E> current = getRoot();
		BTNode<E> parent;
		while(true){
			parent = current;
			if (node.getElement().compareTo(current.getElement()) == 0){	
				// do nothing
				System.out.println("Node" + node.getElement().toString() + "exists!");
				break;
			} else if (node.getElement().compareTo(current.getElement()) < 0){				
				current = current.getLeftChild();
				if(current == null){
					parent.setLeftChild(node);
					break;
				}
			} else {
				current = current.getRightChild();
				if(current == null){
					parent.setRightChild(node);
					break;
				}
			}
		}
	}

	/* It is the delete method. */
	public void delete(BTNode<E> node){
		BTNode<E> target = this.search(node.getElement());
		if (target == null) {
			System.out.println("Did not find the target!");
			return;
		} 
		
		// realDeletedNode is the node we actually delete.
		BTNode<E> realDeletedNode = this.getRealDeletedNode(target);
		// System.out.println(target.toString());
		// System.out.println(realDeletedNode.toString());

		if (realDeletedNode == getRoot()) {
			setRoot(null);
			return;
		}
		// delete the realDeletedNode
		// COMPLETE THIS BLOCK



		// replace the target with the realDeletedNode
		// COMPLETE THIS BLOCK



	}

	public BTNode<E> getRealDeletedNode(BTNode<E> deleleNode){
		BTNode<E> realDeletedNode = deleleNode;

		// find the smallest key in the right subtree
		if (deleleNode.getRightChild() != null) { 
			// COMPLETE THIS BLOCK


		} else if (deleleNode.getLeftChild() != null) {
			// find the largest key in the left subtree
			// COMPLETE THIS BLOCK


		} else {
			// do nothing
		}
		return realDeletedNode;
	}


	public static void main(String[] args) {

		// ------------ test BinarySearchTree
		System.out.println("============================= Test BinarySearchTree");
		// 
		// ----------------------------------
		//             6
		//           /   \
		//         2       9
		//       /   \    /  \
		//      1     4  8   null    
		//       
		
		BTNode<Integer> node1 = new BTNode<Integer>(1, null, null);		
		BTNode<Integer> node4 = new BTNode<Integer>(4, null, null);
		BTNode<Integer> node8 = new BTNode<Integer>(8, null, null);
		
		BTNode<Integer> node2 = new BTNode<Integer>(2, node1, node4);
		BTNode<Integer> node9 = new BTNode<Integer>(9, node8, null);
		
		BTNode<Integer> node6 = new BTNode<Integer>(6, node2, node9);

		node1.setParent(node2);
		node4.setParent(node2);
		node2.setParent(node6);
		node8.setParent(node9);
		node9.setParent(node6);

		BinarySearchTree<Integer> tree = new BinarySearchTree<Integer>(node6);

		System.out.println("Size of the tree: " + tree.size(tree.getRoot()));
		System.out.println("Height of the tree: " + tree.height(tree.getRoot()));
		System.out.print("\ninOrder: ");
		tree.inOrder(tree.getRoot());
		System.out.println("\n");

		// ----------------------- test search
		System.out.println("------------------ Test search");
		System.out.println(tree.search(4).toString());
		System.out.println("\n");
		// ----------------------- test insert
		System.out.println("------------------ Test insert");
		BTNode<Integer> node5 = new BTNode<Integer>(5, null, null);
		tree.insert(node5);
		tree.inOrder(tree.getRoot());
		System.out.println("\n");
		// ----------------------- test delete
		System.out.println("------------------ Test delete 1");
		tree.delete(node4);
		tree.inOrder(tree.getRoot());
		System.out.println("\n");



		// ----------------------- test delete
		// 
		// ----------------------------------
		//              1
		//           /     \
		//         nu       3
		//               /     \
		//             2        8
		//                    /   \
		//                   6     9
		//                  /
		//                 5  
		//       
		
		BTNode<Integer> n2 = new BTNode<Integer>(2, null, null);		
		BTNode<Integer> n5 = new BTNode<Integer>(5, null, null);
		BTNode<Integer> n9 = new BTNode<Integer>(9, null, null);
		
		BTNode<Integer> n6 = new BTNode<Integer>(6, n5, null);
		BTNode<Integer> n8 = new BTNode<Integer>(8, n6, n9);
		BTNode<Integer> n3 = new BTNode<Integer>(3, n2, n8);
		BTNode<Integer> n1 = new BTNode<Integer>(1, null, n3);
		
		n3.setParent(n1);
		n2.setParent(n3);
		n8.setParent(n3);
		n6.setParent(n8);
		n9.setParent(n8);
		n5.setParent(n6);

		BinarySearchTree<Integer> tree2 = new BinarySearchTree<Integer>(n1);
		System.out.println("------------------ Test delete 2");
		tree2.delete(n3);
		tree2.inOrder(tree.getRoot());
		System.out.println("\n");
		System.out.println(n5.toString());
		System.out.println(n2.toString());
		System.out.println(n1.toString());

	}
}
