// package myBinaryTree;

import java.util.Comparator;

// public class BTNode<E extends Comparable<E>> implements Comparable<BTNode<E>> {
public class BTNode<E> {
	// ---------------------------------- data field
	private E element;
	private BTNode<E> parent;
	private BTNode<E> leftChild;
	private BTNode<E> rightChild;
	// ---------------------------------- method field

	// --------------------- constructors
	public BTNode() {
		this.element = null;
		this.parent = null;
		this.leftChild = null;
		this.rightChild = null;
	}
	@SuppressWarnings("unchecked")
	public BTNode(Object element, BTNode<E> leftChild, BTNode<E> rightChild) {
		this.element = (E) element;
		this.parent = null;
		this.leftChild = leftChild;
		this.rightChild = rightChild;
	}

	// --------------------- 
	public E getElement() {
		return this.element;
	}
	public void setElement(E element) {
		this.element = element;
	}

	public BTNode<E> getLeftChild() {
		return this.leftChild;
	}
	public void setLeftChild(BTNode<E> leftChild) {
		this.leftChild = leftChild;
		if(leftChild != null) {
			this.leftChild.parent = this; //
		}
	}

	public BTNode<E> getRightChild() {
		return this.rightChild;
	}
	public void setRightChild(BTNode<E> rightChild) {
		this.rightChild = rightChild;
		if(rightChild != null) {
			this.rightChild.parent = this;
		}
	}

	public BTNode<E> getParent() {
		return this.parent;
	}	
	public void setParent(BTNode<E> parent) {
		this.parent = parent;
		// ....
	}
	public int numChildren() {
		if (this.leftChild == null && this.rightChild == null) {
			return 0;
		} else if (this.leftChild != null && this.rightChild != null) {
			return 2;
		} else {
			return 1;
		}
	}


	public boolean isLeftChild() {
		if(this.parent == null) {
			System.out.println("It is the root");
			return false;
		} 
		if (this.getParent().getLeftChild() == null) {
			return false;
		}
		else if (this.getParent().getLeftChild() != this) {
			return false;
		}
		else {
			return true;
		}
	}

	public BTNode getSibling() {
		if (this.parent == null) {
			System.out.println("It is the root and it has no sibling!");
			return null;
		}
		if (this.isLeftChild()) {
			return this.parent.getRightChild();
		} else {
			return this.parent.getLeftChild();
		}		
		
	}

	@Override
	public String toString() {
		String leftChildString;
		String rightChildString;
		String parentString;
		if (this.getParent() == null) {
			parentString = "null";
		} else {
			parentString = this.getParent().getElement() + "";
		}

		if (this.getLeftChild() == null) {
			leftChildString = "null";
		} else {
			leftChildString = this.getLeftChild().getElement() + "";
		}
		if (this.getRightChild() == null) {
			rightChildString = "null";
		} else {
			rightChildString = this.getRightChild().getElement() + "";
		}

        return this.getElement() + 
        	" with parent " + parentString +
        	" and leftChild: " + leftChildString + 
        	" and rightChild: " + rightChildString;
    }
}




