// ===============================================
// CSCI 3230 Data Structures
// Instructor: Weitian Tong, Ph.D.
//
// Coding Quiz 6
//
// =============================================== Requirements
// Implement a AVLTree class by extending the BinarySearchTree class. 
// Hint: The implementation of binary search tree and binary tree with linked structure are provided 
//  (BinarySearchTree.java, LinkedBinaryTree.java, BTnode.java). 
//
// The output should be:
// 
// 	============================= Test AVLTree
// 	Size of the tree: 5
// 	Height of the tree: 3

// 	inOrder: 3	4	5	7	8	

// 	------------------ Test delete 1
// 	=================== Case 3
// 	3	4	5	7	

// 	4 with parent 5 and leftChild: 3 and rightChild: null
// 	3 with parent 4 and leftChild: null and rightChild: null
// 	5 with parent null and leftChild: 4 and rightChild: 7
//
// =============================================== Note
//
//  1. DO NOT DELETE ANY COMMENT!!!
//  2. Modify the file name to "AVLTree.java" before compiling it.
//
// ===============================================



 
public class AVLTree<E extends Comparable<E>> extends BinarySearchTree<E> {
    
    public AVLTree(BTNode<E> root){
        super(root);
    }

    @Override
    public void insert(BTNode<E> node){
        super.insert(node);
 
        // try to fix the heights!
        BTNode<E> x = null;
        BTNode<E> y = node;
        BTNode<E> z = null;

        trinodeReconstructuring(x, y, z, "insert");
    }

    @Override
    public void delete(BTNode<E> node){
        BTNode<E> siblingOfRealDeletedNode = super.deleteWithReturn(node);
        // System.out.println(siblingOfRealDeletedNode.toString());
        // 
        // try to fix the heights!
        BTNode<E> x = null;
        BTNode<E> y = siblingOfRealDeletedNode;
        BTNode<E> z = null;

        trinodeReconstructuring(x, y, z, "delete");
    }
    
    public void trinodeReconstructuring(BTNode<E> x, BTNode<E> y, BTNode<E> z, String methodName) {
        while (y.getParent() != null) {
            BTNode<E> ySibling = y.getSibling();
            if (Math.abs(height(ySibling) - height(y)) < 2) {
                y = y.getParent();
                // System.out.println(y.toString());
                continue;
            }
            // identify three nodes x, y, z
            if (height(ySibling) - height(y) > 0) {
                y = ySibling; 
            } 
            BTNode<E> yLeftChild = y.getLeftChild();
            BTNode<E> yRightChild = y.getRightChild();
            x = (height(yLeftChild) > height(yRightChild))? yLeftChild :  yRightChild;
            z = y.getParent();

            // System.out.println("=================");
            // System.out.println(x.toString());
            // System.out.println(y.toString());
            // System.out.println(z.toString());

            // Trinode Reconstructuring 
            if(x.getElement().compareTo(y.getElement()) <= 0 && 
                y.getElement().compareTo(z.getElement()) <= 0) {
                // Case 1: x <= y <= z
                System.out.println("=================== Case 1");
                // COMPLETE THIS BLOCK





                if (methodName.equals("insert")) {
                    break;
                }               
            } else if (z.getElement().compareTo(y.getElement()) <= 0 && 
                y.getElement().compareTo(x.getElement()) <= 0) {
                // Case 2: z <= y <= x
                System.out.println("=================== Case 2");
                // COMPLETE THIS BLOCK





                if (methodName.equals("insert")) {
                    break;
                }  
            } else if (y.getElement().compareTo(x.getElement()) <= 0 && 
                x.getElement().compareTo(z.getElement()) <= 0) {
                // Case 3: y <= x <= z
                System.out.println("=================== Case 3");
                // COMPLETE THIS BLOCK






                if (methodName.equals("insert")) {
                    break;
                }  
            } else {
                // Case 4: z <= x <= y
                System.out.println("=================== Case 4");
                // COMPLETE THIS BLOCK






                if (methodName.equals("insert")) {
                    break;
                }  
            }
        }
    } 



    public static void main(String[] args) {

		// ------------ test AVLTree
		System.out.println("============================= Test AVLTree");
		// 
		// ----------------------------------
		//             7
		//           /   \
		//         4       8
		//       /   \    
		//      3     5       
		//       
		
		BTNode<Integer> n3 = new BTNode<Integer>(3, null, null);		
		BTNode<Integer> n5 = new BTNode<Integer>(5, null, null);
		BTNode<Integer> n8 = new BTNode<Integer>(8, null, null);
		
		BTNode<Integer> n4 = new BTNode<Integer>(4, n3, n5);
		BTNode<Integer> n7 = new BTNode<Integer>(7, n4, n8);
		
		n3.setParent(n4);
		n5.setParent(n4);
		n4.setParent(n7);
		n8.setParent(n7);

		AVLTree<Integer> tree = new AVLTree<Integer>(n7);

		System.out.println("Size of the tree: " + tree.size(tree.getRoot()));
		System.out.println("Height of the tree: " + tree.height(tree.getRoot()));
		System.out.print("\ninOrder: ");
		tree.inOrder(tree.getRoot());
		System.out.println("\n");

		
		// ----------------------- test delete
		// ----------------------------------
		//             7                    5
		//           /                    /   \
		//         4                     4     7
		//       /   \                  /       
		//      3     5                3        
		//    
		System.out.println("------------------ Test delete 1");
		tree.delete(n8);
		tree.inOrder(tree.getRoot());
		System.out.println("\n");

		System.out.println(n4.toString());
		System.out.println(n3.toString());
		System.out.println(n5.toString());
	}
    
 }





