
public class BinarySearchTree<E extends Comparable<E>> extends LinkedBinaryTree<E> {

	public BinarySearchTree(BTNode<E> root){
		super(root);
	}
	
	public BTNode<E> search(E key){
		BTNode<E> current = this.getRoot();
		while (current != null) {
			// System.out.println(current.getElement() + "    ");
			if(key.compareTo(current.getElement()) == 0){
				return current;
			}else if(key.compareTo(current.getElement()) < 0){
				current = current.getLeftChild();
			}else{
				current = current.getRightChild();
			}
		}
		System.out.println("Did not find the key!");
		return null;		
	}

	public void insert(BTNode<E> node){
		if(getRoot() == null){
			setRoot(node);
			return;
		}
		BTNode<E> current = getRoot();
		BTNode<E> parent;
		while(true){
			parent = current;
			if (node.getElement().compareTo(current.getElement()) == 0){	
				// do nothing
				System.out.println("Node" + node.getElement().toString() + "exists!");
				// return;
				break;
			} else if (node.getElement().compareTo(current.getElement()) < 0){				
				current = current.getLeftChild();
				if(current == null){
					parent.setLeftChild(node);
					// return;
					break;
				}
			} else {
				current = current.getRightChild();
				if(current == null){
					parent.setRightChild(node);
					// return;
					break;
				}
			}
		}
	}

	public void delete(BTNode<E> node){
		BTNode<E> target = this.search(node.getElement());
		if (target == null) {
			System.out.println("Did not find the target!");
			return;
		} 
		
		// realDeletedNode is the node we actually delete.
		BTNode<E> realDeletedNode = this.getRealDeletedNode(target);
		// System.out.println(target.toString());
		// System.out.println(realDeletedNode.toString());

		if (realDeletedNode == getRoot()) {
			setRoot(null);
			return;
		}
		// delete the realDeletedNode
		if(realDeletedNode.isLeftChild()){
			realDeletedNode.getParent().setLeftChild(null);
		}else{
			realDeletedNode.getParent().setRightChild(null);
		}

		// replace the target with the realDeletedNode
		if (realDeletedNode != target) { 
			if (isRoot(target)) {
				setRoot(realDeletedNode);
			} else {
				if(target.isLeftChild()){
					target.getParent().setLeftChild(realDeletedNode);
				}else{
					target.getParent().setRightChild(realDeletedNode);
				}
			}
			realDeletedNode.setLeftChild(target.getLeftChild());
			realDeletedNode.setRightChild(target.getRightChild());
		}
	}

	public BTNode<E> getRealDeletedNode(BTNode<E> deleleNode){
		BTNode<E> realDeletedNode = deleleNode;

		// // find the smallest key in the right subtree
		// if (deleleNode.getRightChild() != null) { 
		// 	// System.out.println(deleleNode.getElement() + "========" + deleleNode.getRightChild().getElement());
		// 	BTNode<E> child = deleleNode.getRightChild();
		// 	while (child != null) {
		// 		realDeletedNode = child;
		// 		child = child.getLeftChild();
		// 	}
		// } else if (deleleNode.getLeftChild() != null) {
		// 	// find the largest key in the left subtree
		// 	// System.out.println(deleleNode.getElement() + "========" + deleleNode.getLeftChild().getElement());
		// 	BTNode<E> child = deleleNode.getLeftChild();
		// 	while (child != null) {
		// 		realDeletedNode = child;
		// 		child = child.getRightChild(); 
		// 	}
		// } else {
		// 	// do nothing
		// 	// System.out.println(deleleNode.getElement() + "======== has no children!");

		// }

		// find the smallest key in the right subtree
		
		if (deleleNode.getLeftChild() != null) {
			// find the largest key in the left subtree
			// System.out.println(deleleNode.getElement() + "========" + deleleNode.getLeftChild().getElement());
			BTNode<E> child = deleleNode.getLeftChild();
			while (child != null) {
				realDeletedNode = child;
				child = child.getRightChild(); 
			}
		} else if (deleleNode.getRightChild() != null) { 
			// System.out.println(deleleNode.getElement() + "========" + deleleNode.getRightChild().getElement());
			BTNode<E> child = deleleNode.getRightChild();
			while (child != null) {
				realDeletedNode = child;
				child = child.getLeftChild();
			}
		} else {
			// do nothing
			// System.out.println(deleleNode.getElement() + "======== has no children!");

		}

		return realDeletedNode;
	}

	public BTNode<E> deleteWithReturn(BTNode<E> node){
        BTNode<E> target = this.search(node.getElement());
        if (target == null) {
            System.out.println("Did not find the target!");
            return null;
        } 
        
        // realDeletedNode is the node we actually delete.
        BTNode<E> realDeletedNode = this.getRealDeletedNode(target);
        if (realDeletedNode == getRoot()) {
            setRoot(null);
            return null;
        }

        BTNode<E> siblingOfRealDeletedNode = realDeletedNode.getSibling();

        // delete the realDeletedNode
        if(realDeletedNode.isLeftChild()){
            realDeletedNode.getParent().setLeftChild(null);
        }else{
            realDeletedNode.getParent().setRightChild(null);
        }
        // replace the target with the realDeletedNode
        if (realDeletedNode != target) { 
        	if (isRoot(target)) {
				setRoot(realDeletedNode);
			} else {
	            if(target.isLeftChild()){
	                target.getParent().setLeftChild(realDeletedNode);
	            }else{
	                target.getParent().setRightChild(realDeletedNode);
	            }
	        }
            realDeletedNode.setLeftChild(target.getLeftChild());
            realDeletedNode.setRightChild(target.getRightChild());
        }
        return siblingOfRealDeletedNode;
	}
}
