// package myBinaryTree;

public class LinkedBinaryTree<E> {
	// ---------------------------------- data field
	private BTNode<E> root;
	// int height;
	// ---------------------------------- method field

	// --------------------- constructors
	public LinkedBinaryTree(BTNode<E> root) {
		this.root = root;
		// this.height = 0;
	}
	
	// --------------------- 
	public BTNode<E> getRoot(){
		return this.root;
	}
	public void setRoot(BTNode<E> root){
		root.setColor("Black"); // for red-black tree
		root.setParent(null);
		
		this.root = root;
	}
	public int size(BTNode<E> node) {
		if(node == null) {
			return 0;
		} else {
			return 1  + size(node.getLeftChild()) + size(node.getRightChild());
		}
	}

	public boolean isEmpty() {
		return (this.size(this.root)==0);
		// returen (this.root == null);
	}

	public boolean isInternal(BTNode<E> node) {
		return (node.getLeftChild() != null || node.getRightChild() != null);
	}

	public boolean isExternal(BTNode<E> node) {
		return (node.getLeftChild() == null && node.getRightChild() == null);
	}

	// public boolean isRightChild(BTNode<E> node) {
	// 	if (node == getRoot()) {
	// 		// java.lang.System.exit();
	// 		return false;
	// 	}
	// 	if (node.getParent().getRightChild() == null)
	// 		return false;
	// 	else if (node.getParent().getRightChild() != node)
	// 		return false;
	// 	else 
	// 		return true;
	// }
	// public boolean isLeftChild(BTNode<E> node) {
	// 	// make sure node is not the root
	// 	if (node == getRoot()) {
	// 		// java.lang.System.exit();
	// 		return false;
	// 	}
	// 	if (node.getParent().getLeftChild() == null) {
	// 		return false;
	// 	}
	// 	else if (node.getParent().getLeftChild() != node) {
	// 		return false;
	// 	}
	// 	else {
	// 		return true;
	// 	}
	// }
	public int height(BTNode node) {
		if (node == null){
			return 0;
		}
		if(this.isExternal(node)) {
			return 1; 
		} else if (node.getLeftChild() != null && node.getRightChild() != null){
			return 1 + Math.max(height(node.getLeftChild()), height(node.getRightChild()));
		} else if (node.getLeftChild() == null && node.getRightChild() != null){
			return 1 + height(node.getRightChild());
		} else {
			return 1 + height(node.getLeftChild());
		}
	}

	public boolean isRoot(BTNode node) {
		return node == this.root;
	}
	// Traversals
	public void inOrder(BTNode<E> node) {
		if(node == null) {
			return ;
		}
		if(node.getLeftChild() != null) {
			inOrder(node.getLeftChild());
		}

		System.out.print(node.getElement() + "	");
		
		if(node.getRightChild() != null) {
			inOrder(node.getRightChild());
		}
	}
	
	public void preOrder(BTNode<E> node) {
		if(node == null) {
			return ;
		}
		System.out.print(node.getElement() + "	");
		if(node.getLeftChild() != null) {
			preOrder(node.getLeftChild());
		}
		if(node.getRightChild() != null) {
			preOrder(node.getRightChild());
		}
	}
	
	public void postOrder(BTNode<E> node) {
		if(node == null) {
			return ;
		}
		if(node.getLeftChild() != null) {
			postOrder(node.getLeftChild());
		}
		if(node.getRightChild() != null) {
			postOrder(node.getRightChild());
		}
		System.out.print(node.getElement() + "	");
	}

}
